### Hierarchy

- SearchManagerImpl

### Implements

- SearchManager

## Index

### Constructors

- constructor

### Methods

- addEventToOfferSearch
- addResultItem
- claimPurchaseForSearchItem
- cloneOfferSearch
- cloneRequest
- complainToSearchItem
- confirmSearchItem
- createRequest
- createSearchResultByQuery
- deleteRequest
- evaluateSearchItem
- getCountBySearchRequestIds
- getInteractions
- getMyRequests
- getMySearchRequestsByTag
- getRequestsByOwnerAndId
- getRequestsByPage
- getSearchRequestsByOwnerAndTag
- getSearchResult
- getSearchResultByOfferSearchId
- getSuggestionByQuery
- getUserOfferSearches
- rejectSearchItem
- updateRequest

## Constructors

### constructor

- new SearchManagerImpl(requestRepository: SearchRequestRepository, offerSearchRepository: OfferSearchRepository, authAccountBehavior: Observable<Account>): SearchManagerImpl

- - Defined in manager/SearchManagerImpl.ts:16

  #### Parameters

  - ##### requestRepository: SearchRequestRepository

  - ##### offerSearchRepository: OfferSearchRepository

  - ##### authAccountBehavior: Observable<Account>

  #### Returns SearchManagerImpl

## Methods

### addEventToOfferSearch

- addEventToOfferSearch(event: string, offerSearchId: number): Promise<void>

- Implementation of SearchManager.addEventToOfferSearch

  - Defined in manager/SearchManagerImpl.ts:165

  #### Parameters

  - ##### event: string

  - ##### offerSearchId: number

  #### Returns Promise<void>

### addResultItem

- addResultItem(offerSearch: OfferSearch): Promise<void>

- Implementation of SearchManager.addResultItem

  - Defined in manager/SearchManagerImpl.ts:161

  #### Parameters

  - ##### offerSearch: OfferSearch

  #### Returns Promise<void>

### claimPurchaseForSearchItem

- claimPurchaseForSearchItem(searchResultId: number): Promise<void>

- Implementation of SearchManager.claimPurchaseForSearchItem

  - Defined in manager/SearchManagerImpl.ts:157

  #### Parameters

  - ##### searchResultId: number

  #### Returns Promise<void>

### cloneOfferSearch

- cloneOfferSearch(id: number, searchRequest: SearchRequest): Promise<Array<OfferSearch>>

- Implementation of SearchManager.cloneOfferSearch

  - Defined in manager/SearchManagerImpl.ts:42

  #### Parameters

  - ##### id: number

  - ##### searchRequest: SearchRequest

  #### Returns Promise<Array<OfferSearch>>

### cloneRequest

- cloneRequest(searchRequest: SearchRequest): Promise<SearchRequest>

- Implementation of SearchManager.cloneRequest

  - Defined in manager/SearchManagerImpl.ts:38

  #### Parameters

  - ##### searchRequest: SearchRequest

  #### Returns Promise<SearchRequest>

### complainToSearchItem

- complainToSearchItem(searchResultId: number): Promise<void>

- Implementation of SearchManager.complainToSearchItem

  - Defined in manager/SearchManagerImpl.ts:141

  #### Parameters

  - ##### searchResultId: number

  #### Returns Promise<void>

### confirmSearchItem

- confirmSearchItem(searchResultId: number): Promise<void>

- Implementation of SearchManager.confirmSearchItem

  - Defined in manager/SearchManagerImpl.ts:153

  #### Parameters

  - ##### searchResultId: number

  #### Returns Promise<void>

### createRequest

- createRequest(searchRequest: SearchRequest): Promise<SearchRequest>

- Implementation of SearchManager.createRequest

  - Defined in manager/SearchManagerImpl.ts:30

  #### Parameters

  - ##### searchRequest: SearchRequest

  #### Returns Promise<SearchRequest>

### createSearchResultByQuery

- createSearchResultByQuery(query: string, searchRequestId: number, page?: number, size?: number, interests?: Array<string>, mode?: OfferSearchRequestInterestMode): Promise<Page<OfferSearchResultItem>>

- Implementation of SearchManager.createSearchResultByQuery

  - Defined in manager/SearchManagerImpl.ts:76

  #### Parameters

  - ##### query: string

  - ##### searchRequestId: number

  - ##### Optional page: number

  - ##### Optional size: number

  - ##### Optional interests: Array<string>

  - ##### Optional mode: OfferSearchRequestInterestMode

  #### Returns Promise<Page<OfferSearchResultItem>>

### deleteRequest

- deleteRequest(id: number): Promise<number>

- Implementation of SearchManager.deleteRequest

  - Defined in manager/SearchManagerImpl.ts:68

  #### Parameters

  - ##### id: number

  #### Returns Promise<number>

### evaluateSearchItem

- evaluateSearchItem(searchResultId: number): Promise<void>

- Implementation of SearchManager.evaluateSearchItem

  - Defined in manager/SearchManagerImpl.ts:149

  #### Parameters

  - ##### searchResultId: number

  #### Returns Promise<void>

### getCountBySearchRequestIds

- getCountBySearchRequestIds(searchRequestIds: Array<number>): Promise<Map<number, number>>

- Implementation of SearchManager.getCountBySearchRequestIds

  - Defined in manager/SearchManagerImpl.ts:95

  #### Parameters

  - ##### searchRequestIds: Array<number>

  #### Returns Promise<Map<number, number>>

### getInteractions

- getInteractions(offerIds?: Array<number> | undefined, states?: Array<OfferResultAction> | undefined, owner?: string | undefined): Promise<Array<OfferInteraction>>

- Implementation of SearchManager.getInteractions

  - Defined in manager/SearchManagerImpl.ts:120

  #### Parameters

  - ##### Optional offerIds: Array<number> | undefined

  - ##### Optional states: Array<OfferResultAction> | undefined

  - ##### Optional owner: string | undefined

  #### Returns Promise<Array<OfferInteraction>>

### getMyRequests

- getMyRequests(id?: number): Promise<Array<SearchRequest>>

- Implementation of SearchManager.getMyRequests

  - Defined in manager/SearchManagerImpl.ts:46

  #### Parameters

  - ##### Optional id: number

  #### Returns Promise<Array<SearchRequest>>

### getMySearchRequestsByTag

- getMySearchRequestsByTag(tag: string): Promise<Array<SearchRequest>>

- Implementation of SearchManager.getMySearchRequestsByTag

  - Defined in manager/SearchManagerImpl.ts:173

  #### Parameters

  - ##### tag: string

  #### Returns Promise<Array<SearchRequest>>

### getRequestsByOwnerAndId

- getRequestsByOwnerAndId(owner: string, id?: number): Promise<Array<SearchRequest>>

- Implementation of SearchManager.getRequestsByOwnerAndId

  - Defined in manager/SearchManagerImpl.ts:55

  #### Parameters

  - ##### owner: string

  - ##### Optional id: number

  #### Returns Promise<Array<SearchRequest>>

### getRequestsByPage

- getRequestsByPage(page?: number, size?: number): Promise<Page<SearchRequest>>

- Implementation of SearchManager.getRequestsByPage

  - Defined in manager/SearchManagerImpl.ts:64

  #### Parameters

  - ##### Optional page: number

  - ##### Optional size: number

  #### Returns Promise<Page<SearchRequest>>

### getSearchRequestsByOwnerAndTag

- getSearchRequestsByOwnerAndTag(owner: string, tag: string): Promise<Array<SearchRequest>>

- Implementation of SearchManager.getSearchRequestsByOwnerAndTag

  - Defined in manager/SearchManagerImpl.ts:169

  #### Parameters

  - ##### owner: string

  - ##### tag: string

  #### Returns Promise<Array<SearchRequest>>

### getSearchResult

- getSearchResult(searchRequestId: number, page?: number, size?: number): Promise<Page<OfferSearchResultItem>>

- Implementation of SearchManager.getSearchResult

  - Defined in manager/SearchManagerImpl.ts:99

  #### Parameters

  - ##### searchRequestId: number

  - ##### Optional page: number

  - ##### Optional size: number

  #### Returns Promise<Page<OfferSearchResultItem>>

### getSearchResultByOfferSearchId

- getSearchResultByOfferSearchId(offerSearchId: number, page?: number, size?: number): Promise<Page<OfferSearchResultItem>>

- Implementation of SearchManager.getSearchResultByOfferSearchId

  - Defined in manager/SearchManagerImpl.ts:128

  #### Parameters

  - ##### offerSearchId: number

  - ##### Optional page: number

  - ##### Optional size: number

  #### Returns Promise<Page<OfferSearchResultItem>>

### getSuggestionByQuery

- getSuggestionByQuery(query: string, size?: number): Promise<Array<string>>

- Implementation of SearchManager.getSuggestionByQuery

  - Defined in manager/SearchManagerImpl.ts:72

  #### Parameters

  - ##### query: string

  - ##### Optional size: number

  #### Returns Promise<Array<string>>

### getUserOfferSearches

- getUserOfferSearches(page?: number, size?: number, unique?: boolean, searchIds?: Array<number>, state?: Array<OfferResultAction>, sort?: SortOfferSearch, interaction?: boolean): Promise<Page<OfferSearchResultItem>>

- Implementation of SearchManager.getUserOfferSearches

  - Defined in manager/SearchManagerImpl.ts:107

  #### Parameters

  - ##### Default value page: number = 0

  - ##### Default value size: number = 20

  - ##### Default value unique: boolean = false

  - ##### Default value searchIds: Array<number> = []

  - ##### Default value state: Array<OfferResultAction> = []

  - ##### Optional sort: SortOfferSearch

  - ##### Optional interaction: boolean

  #### Returns Promise<Page<OfferSearchResultItem>>

### rejectSearchItem

- rejectSearchItem(searchResultId: number): Promise<void>

- Implementation of SearchManager.rejectSearchItem

  - Defined in manager/SearchManagerImpl.ts:145

  #### Parameters

  - ##### searchResultId: number

  #### Returns Promise<void>

### updateRequest

- updateRequest(searchRequest: SearchRequest): Promise<SearchRequest>

- Implementation of SearchManager.updateRequest

  - Defined in manager/SearchManagerImpl.ts:34

  #### Parameters

  - ##### searchRequest: SearchRequest

  #### Returns Promise<SearchRequest>

Generated using TypeDoc